-- animal.e class hierarchy for benchmark tests.
-- Adapted from Rod Jackson's Quartz.
without warning                          
without trace 
       
                  
include ..\method_euphoria.e 
                  
                  
package("ME_Demo")


global constant Animal=class("Animal",Entity,NONE)

property("name",INSTANCE,PRIVATE,PRIVATE,NONE) 
property("is_domesticated",INSTANCE,PRIVATE,PRIVATE,FALSE)

function Animal_new(object name,object is_domesticated)
   entity new 
   new=call_super(NONE)
   set_property(new,"name",name)
   set_property(new,"is_domesticated",is_domesticated)
   return new
end function
method("new",CLASS,PUBLIC,2,routine_id("Animal_new"))

super_method("clone",INSTANCE)

super_method("delete",INSTANCE)

function Animal_make_noise()      
   return NOTHING
end function
method("make_noise",INSTANCE,PUBLIC,0,routine_id("Animal_make_noise"))

end_class()


global constant Mammal=class("Mammal",Animal,NONE)

property("has_tail",INSTANCE,PRIVATE,PRIVATE,TRUE)
property("has_fur",INSTANCE,PRIVATE,PRIVATE,TRUE)
property("is_aquatic",INSTANCE,PRIVATE,PRIVATE,FALSE)

function Mammal_new (object name, object is_domesticated,object has_tail,
object has_fur,object is_aquatic)
   entity new
   new=call_super({name,is_domesticated})
   set_property(new,"has_tail",has_tail)
   set_property(new,"has_fur", has_fur)
   set_property(new,"is_aquatic",is_aquatic)
   return new
end function
method("new",CLASS,PUBLIC,5,routine_id("Mammal_new"))

end_class()


global constant Cat=class("Cat",Mammal,NONE)

property("is_declawed",INSTANCE,PRIVATE,PRIVATE,FALSE)   

function Cat_get_declawed(integer times)
   integer junk
   for i=1 to times do
      junk=get_property(this(),"is_declawed")      
   end for
   return NOTHING
end function                                        
method("get_declawed",INSTANCE,PUBLIC,1,routine_id("Cat_get_declawed"))                                             
             
function Cat_set_declawed(integer times)
   for i=1 to times do
      set_property(this(),"is_declawed",FALSE)      
   end for
   return NOTHING
end function                                             
method("set_declawed",INSTANCE,PUBLIC,1,routine_id("Cat_set_declawed"))                                             

end_class()


end_package()
             


