without trace  
without warning
   
 
include ..\me_widgets.e  
include get.e


package("ME_Demo")          


constant My_Widget=class("My_Widget",Component,NONE)

property("x_counter",INSTANCE,PRIVATE,PRIVATE,0) 

event("w",PUBLIC,PUBLIC)
event("x",PUBLIC,PUBLIC)
event("y",PUBLIC,PUBLIC)
event("z",PUBLIC,PUBLIC)

function My_Widget_new(object name)
   object new,ex,wrapper
   new=call_super({name}) 
   if failure() then return NOTHING end if  
   for i=0 to 3 do
      wrapper=call_method(Method_Wrapper,"new",{new,"before_"&('w'+i)})
      if success() then 
         VOID=call_method(new,"set_"&("w"+i),{wrapper})
      end if
      if catch(Exception) then
         ex=caught() 
         VOID=call_method(new,"delete",NONE)
         throw(ex)
         return NOTHING
      end if
   end for
   return new
end function                             
method("new",CLASS,PUBLIC,1,routine_id("My_Widget_new"))  

procedure My_Widget_before_w() 
   puts(1,"Event w raised on "&call_method(this(),"get_name",NONE)&".\n")    
end procedure 
method("before_w",INSTANCE,PRIVATE,0,{routine_id("My_Widget_before_w")})
 
function My_Widget_before_x()
   integer xctr
   sequence message,name
   name=call_method(this(),"get_name",NONE)                    
   xctr=get_property(this(),"x_counter")+1         
   set_property(this(),"x_counter",xctr)
   if xctr>5 then 
      message="x event on "&name&" cancelled."
      puts(1,message&"\n") 
      return message
   end if
   puts(1,"x event raised on "&name&".\n")
   return NOTHING
end function                        
method("before_x",INSTANCE,PRIVATE,0,routine_id("My_Widget_before_x"))
                        
procedure My_Widget_before_y()           
   printf(1,"The value of "&call_method(this(),"get_name",NONE)&"'s "
    &"x counter is %d.\n",{get_property(this(),"x_counter")})
   VOID=call_method(this(),"x",NONE)
end procedure 
method("before_y",INSTANCE,PRIVATE,0,{routine_id("My_Widget_before_y")})
     
function My_Widget_before_z() 
   sequence message      
   object ret
   message=call_method(this(),"get_name",NONE)&"'s x counter is "         
   if remainder(get_property(this(),"x_counter"),2)=0 then 
      message&="even."
      ret=NOTHING
   else
      message&="odd."   
      ret=message 
   end if         
   puts(1,message&"\n")
   return ret
end function
method("before_z",INSTANCE,PRIVATE,0,routine_id("My_Widget_before_z"))
 
end_class()  
           
           
constant My_Handlers=class("My_Handlers",Entity,NONE)

procedure My_Handlers_handler(object target,object event)
   puts(1,"My_Widget "&call_method(target,"get_name",NONE)&"'s "
   &event&" event handler.\n")    
end procedure
method("handler",CLASS,PUBLIC,2,{routine_id("My_Handlers_handler")}) 

procedure My_Handlers_second_handler(object target,object event)
   puts(1,"My_Widget "&call_method(target,"get_name",NONE)&"'s second "
   &event&" event handler.\n")    
end procedure
method("second_handler",CLASS,PUBLIC,2,
{routine_id("My_Handlers_second_handler")})   
  

end_class()


constant Event=class("Event",Entity,NONE)

procedure Event_main()
   sequence MyWidget_seq 
   entity wrapper
   sequence handlers
   sequence randno    
   MyWidget_seq=NONE
   for i=0 to 4 do
      MyWidget_seq&={call_method(My_Widget,"new",{"A"+i})}
   end for
   for i=1 to 5 do
      wrapper=call_method(Method_Wrapper,"new",{My_Handlers,"handler"})   
      for j=0 to 2 do  
         handlers=call_method(MyWidget_seq[i],"get_"&("w"+j),NONE)
         handlers=append(handlers,wrapper) 
         VOID=call_method(MyWidget_seq[i],"set_"&("w"+j),{handlers})
      end for 
      handlers=append(call_method(MyWidget_seq[i],"get_z",NONE),wrapper)
      wrapper=call_method(Method_Wrapper,"new",{My_Handlers,"second_handler"})
      handlers=append(handlers,wrapper)
      VOID=call_method(MyWidget_seq[i],"set_z",{handlers}) 
   end for
   puts(1,"Press any key to continue, press ESC to quit.\n\n")
   for i=1 to 200 do
      randno=rand({5,4})
      printf(1,"%d) ",i)
      VOID=call_method(MyWidget_seq[randno[1]],("w"+randno[2]-1),NONE)
      if wait_key()=27 then exit end if     
      puts(1,"\n")
   end for
end procedure
method("main",CLASS,PRIVATE,0,{routine_id("Event_main")})

end_class()


end_package()


main_program(Event)

