-- globals.ex by Mike Nelson 
-- a program to extract global keywords from a Euphoria include file
                   
include get.e   
include wildcard.e     
include ..\me_containers.e  

integer fn
object token_line        

function fix(object x)
   integer index 
   if atom(x) then return x end if
   x=upper(x)
   while TRUE do
      index=find('_',x)
      if index=NIL then return x end if
      x[index]=' '
   end while
end function

function get_token()
   integer index,len 
   sequence token
   if atom(token_line) then return {} end if
   len=length(token_line)
   while len=0 do
      token_line=gets(fn)
      if atom(token_line) then 
         close(fn)
         return {}
      end if
      len=length(token_line)
   end while        
   if identifier(token_line[1..1]) then
      for i=1 to len do
         if not identifier(token_line[1..i]) then
            token=token_line[1..i-1]
            token_line=token_line[i..len]
            return token
         end if
         if i=len then
            token=token_line
            token_line="" 
            return token
         end if  
      end for 
   elsif token_line[1]='"' then
      for i=2 to len do
         if token_line[i]='\\' then
            if i=len then return {} end if
            if not find(token_line[i+1],"nrt'\"\\") then return {} end if
            token_line[i+1]=' '
         end if
         if token_line[i]='"' then
            token=token_line[1..i]
            token_line=token_line[i+1..len]
            return token
         end if 
         if i=len then 
            token_line=-1
            return {} 
         end if
      end for 
   elsif token_line[1]='\'' then 
      for i=2 to len do 
         if token_line[i]='\\' then
            if i=len then return {} end if
            if not find(token_line[i+1],"nrt'\"\\") then return {} end if
            token_line[i+1]=' '
         end if
         if token_line[i]='\'' then
            token=token_line[1..i]
            token_line=token_line[i+1..len]
            return token
         end if 
         if i=len then
            token_line=-1
            return {}
         end if 
      end for
   elsif find(token_line[1],{0,1,2,3,4,5,6,7,8,9}) then
      for i=1 to len do
         if not find(token_line[i],{0,1,2,3,4,5,6,7,8,9}) then
            token=token_line[1..i-1]
            token_line=token_line[i..len]
            return token
         end if
         if i=len then
            token=token_line
            token_line=""
            return token
         end if      
      end for      
   elsif token_line[1]=' ' then
      while len>0 and token_line[1]=' ' do
         token_line=token_line[2..len]
         len-=1   
      end while
      return get_token()
   elsif len>1 and equal(token_line[1..2],"--") then
      index=find('\n',token_line)
      if index=0 then
         token_line=""
      else            
         token_line=token_line[index+1..len]
      end if
      return get_token()
   elsif token_line[1]='\r' then
      token_line=token_line[2..len]
      return get_token()
   elsif token_line[1]='\n' then
      token_line=token_line[2..len]
      return get_token()
   else
      token=token_line[1..1]
      token_line=token_line[2..len]
      return token
   end if      
end function


package("ME_Demo")


constant Global_Extractor=class("Global_Extractor",Multi_Map,NONE)

procedure Global_Extractor_main(object cl) 
   integer new_token,out  
   sequence token
   object filename
   entity Extractor      
   Extractor=call_method(Global_Extractor,"new",NONE)
   if length(cl)<3 then
      puts(1,"Enter name of file to extract globals from:  ")
      filename=gets(0)
      puts(1,"\n")
      if atom(filename) then 
         filename="" 
      else 
         filename=filename[1..length(filename)-1]
      end if
      if equal(filename,"") then
         fatal_error("No file name given, aborting.")
      end if   
   else
      filename=cl[3]
   end if
   fn=open(filename,"rb")
   if fn=-1 then
      fatal_error("Unable to open file "&filename&", aborting.")
   end if  
   token_line=NONE
   new_token=TRUE
   while TRUE do
      if new_token then token=get_token() end if
      new_token=TRUE
      if equal(token,NONE) then exit end if
      if equal(token,"global") then 
         token=get_token()
         if equal(token,NONE) then exit end if
         while TRUE do
            token=get_token()
            if equal(token,NONE) then exit end if 
            VOID=call_method(Extractor,"add",{fix(token),token})
            if catch(Exception) then
               puts(1,"Unknown error processing: "&token&"\n")
            end if
            token=get_token()
            if not equal(token,",") then 
               new_token=FALSE 
               exit
            end if
         end while   
         if equal(token,NONE) then exit end if
      end if      
   end while 
   out=open("globals.txt","w")
   puts(out,"{")
   for i=1 to call_method(Extractor,"get_size",NONE) do 
      if i>1 then
         puts(out,",\n")
      end if 
      token=call_method(Extractor,"get",{i})
      printf(out,"\"%s\"",{token})
   end for     
   puts(out,"}\n")                                           
   close(out)
   puts(1,"Done.\n")   
end procedure     
method("main",CLASS,PRIVATE,-1,{routine_id("Global_Extractor_main")})  

end_class()


end_package()


main_program(Global_Extractor)   


