-- me_counted.e v3.0.0 by Mike Nelson
-- Requires Euphoria 2.5
-- Method Euphoria Standard Class Library     
-- Instance-counted classes, including Singleton
                 
without trace    
without warning

include method_euphoria.e


package("ME_Std_lib")
package("Counted") 


global constant Too_Many_Instances=
exception("Too_Many_Instances",Exception) 


global constant Counted_Instances=class("Counted_Instances",Entity,NONE)  

property("count",CLASS,PUBLIC,PRIVATE,0) 
property("maximum",CLASS,PUBLIC,PRIVATE,0) 

procedure Counted_Instances_initialize(object maximum) 
   if integer(maximum) and maximum>0 then 
      set_property(this(),"maximum",maximum)
   end if
end procedure
method("initialize",CLASS,PROTECTED,1,
{routine_id("Counted_Instances_initialize")})

function Counted_Instances_new()
   integer count,maximum
   count=get_property(this_class(),"count")
   maximum=get_property(this_class(),"maximum")
   if maximum>0 and count>=maximum then
      throw(Too_Many_Instances)
      return NOTHING   
   end if
   set_property(this_class(),"count",count+1)
   return call_super(NONE)   
end function                          
method("new",CLASS,PROTECTED,0,routine_id("Counted_Instances_new"))  
method("clone",INSTANCE,PROTECTED,0,routine_id("Counted_Instances_new"))

function Counted_Instances_delete()
   integer count
   count=get_property(this_class(),"count")
   set_property(this_class(),"count",count-1)
   return call_super(NONE)   
end function    
method("delete",INSTANCE,PROTECTED,0,routine_id("Counted_Instances_delete"))

procedure Counted_Instances_deserialize()
   integer count,maximum
   count=get_property(this_class(),"count") 
   set_property(this_class(),"count",count+1)
   maximum=get_property(this_class(),"maximum") 
   if maximum>0 and count>=maximum then  
      VOID=call_method(this(),"delete",NONE) 
      return    
   end if
end procedure   
method("deserialize",INSTANCE,PRIVATE,0,
{routine_id("Counted_Instances_deserialize")})

end_class()


global constant Singleton=class("Singleton",Counted_Instances,NONE) 

function Singleton_initialize()
   return call_super({1})   
end function
method("initialize",CLASS,PROTECTED,0,routine_id("Singleton_initialize"))

end_class()  
 
 
end_package()
end_package()



 

  

