-- me_widgets.e v3.0.0 by Mike Nelson    
-- Requires Euphoria 2.5   
-- Method Euphoria Standard Class Library   
-- Components and Visual Basic style collections. 
 
              
without trace 
without warning 

include me_containers.e    


package("ME_Std_Lib")
package("Widgets")   


sequence COLLECTION


global constant Component=class("Component",Entity,NONE)  

property("name",INSTANCE,PUBLIC,PRIVATE,NONE)
property("collection",INSTANCE,PUBLIC,PRIVATE,NOTHING) 

function Component_new(object name)
   entity new
   validate(name,"identifier",REQUIRED)
   if failure() then return NOTHING end if 
   new=call_super(NONE)
   set_property(new,"name",name)
   return new
end function   
method("new",CLASS,PROTECTED,1,routine_id("Component_new"))

null_method("clone",INSTANCE,PROTECTED,NOTHING)

function Component_delete() 
   integer index 
   object collection
   collection=get_property(this(),"collection")
   if not equal(collection,NOTHING) then
      index=call_method(collection,"find",{get_property(this(),"name")})
      VOID=call_method(collection,"remove",{index})
   end if
   return call_super(NONE)
end function
method("delete",INSTANCE,PROTECTED,0,routine_id("Component_delete"))  

procedure Component_set_collection()
   object oldColl,newColl
   oldColl=get_property(this(),"collection") 
   newColl=last()
   if equal(oldColl,NOTHING) then
      if instance_of(newColl,COLLECTION) then
         if call_method(newColl,"find",{get_property(this(),"name")})>0 then
            set_property(this(),"collection",newColl)
         end if      
      end if                     
   elsif equal(oldColl,newColl) then
      set_property(this(),"collection",NOTHING)
   end if                                      
end procedure   
method("set_collection",INSTANCE,PUBLIC,0,
{routine_id("Component_set_collection")})

end_class()  


global constant Collection=class("Collection",Map,NONE)

function Collection_new(object component_class)    
   validate(component_class,{"class",Component},OPTIONAL)
   if equal(component_class,NOTHING) then
      component_class=Component  
   else 
      component_class=get_class(component_class) 
   end if
   if failure() then return NOTHING end if
   return call_super(NONE)
end function
method("new",CLASS,PUBLIC,1,routine_id("Collection_new"))  

null_method("clone",INSTANCE,PUBLIC,NOTHING)

function Collection_get_component_class()
   sequence data_type   
   data_type=call_method(this(),"get_data_type",NONE)
   return data_type[2]
end function          
method("get_component_class",INSTANCE,PUBLIC,0,
routine_id("Collection_get_component_class"))

function Collection_add(object component)
   integer index
   sequence data_type,name
   object collection  
   data_type=call_method(this(),"get_data_type",NONE)
   validate(component,data_type,REQUIRED) 
   if failure() then return NIL end if  
   collection=call_method(component,"get_collection",NONE) 
   if equal(collection,this()) then return NIL end if 
   name=call_method(component,"get_name",NONE)
   if not equal(collection,NOTHING) then
      index=call_method(collection,"find",{name})
      VOID=call_method(collection,"remove",{index})
      if failure() then return NIL end if
   end if 
   index=call_super({name,component})
   if success() then
      VOID=call_method(component,"set_collection",NONE)
   end if 
   return index
end function
method("add",INSTANCE,PUBLIC,1,routine_id("Collection_add"))  

function Collection_remove(object index)
   object component 
   component=call_super({index}) 
   if failure() then return NOTHING end if
   VOID=call_method(component,"set_collection",NONE)
   return component   
end function                 
method("remove",INSTANCE,PUBLIC,1,routine_id("Collection_remove"))

procedure Collection_clear()
   sequence components
   components=call_method(this(),"get_data",NONE)
   VOID=call_super(NONE)
   if failure() then return end if
   for i=1 to length(components) do
      VOID=call_method(components[i],"set_collection",NONE)
   end for                                                               
end procedure     
method("clear",INSTANCE,PUBLIC,0,{routine_id("Collection_clear")})


end_class()   

COLLECTION=Collection 


end_package()
end_package()
  

